<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from loginsecurity/xml/schema/CRM/Loginsecurity/LoginSecurityDevice.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:db2eba31ce0f76e01c4e8dc6bc0506d4)
 */
use CRM_Loginsecurity_ExtensionUtil as E;

/**
 * Database access object for the LoginSecurityDevice entity.
 */
class CRM_Loginsecurity_DAO_LoginSecurityDevice extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_login_security_device';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique LoginSecurityIp ID
   *
   * @var int
   */
  public $id;

  /**
   * FK to Contact
   *
   * @var int
   */
  public $contact_id;

  /**
   * Session ID the contact
   *
   * @var string
   */
  public $session_id;

  /**
   * IP address of the contact
   *
   * @var string
   */
  public $ip_address;

  /**
   * User Agent of the contact
   *
   * @var string
   */
  public $user_agent;

  /**
   * Browser fingerprint
   *
   * @var text
   */
  public $fingerprint;

  /**
   * Whether the IP address has been validated
   *
   * @var bool
   */
  public $is_trusted;

  /**
   * Date when the IP address was first seen
   *
   * @var timestamp
   */
  public $first_seen;

  /**
   * Date when the IP address was last seen
   *
   * @var timestamp
   */
  public $last_seen;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_login_security_device';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Login Security Devices') : E::ts('Login Security Device');
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'contact_id', 'civicrm_contact', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => E::ts('Unique LoginSecurityIp ID'),
          'required' => TRUE,
          'where' => 'civicrm_login_security_device.id',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'contact_id' => [
          'name' => 'contact_id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => E::ts('FK to Contact'),
          'where' => 'civicrm_login_security_device.contact_id',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'FKClassName' => 'CRM_Contact_DAO_Contact',
          'add' => NULL,
        ],
        'session_id' => [
          'name' => 'session_id',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Session ID'),
          'description' => E::ts('Session ID the contact'),
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civicrm_login_security_device.session_id',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'ip_address' => [
          'name' => 'ip_address',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('IP Address'),
          'description' => E::ts('IP address of the contact'),
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civicrm_login_security_device.ip_address',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'user_agent' => [
          'name' => 'user_agent',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('User Agent'),
          'description' => E::ts('User Agent of the contact'),
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civicrm_login_security_device.user_agent',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'fingerprint' => [
          'name' => 'fingerprint',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Device Fingerprint'),
          'description' => E::ts('Browser fingerprint'),
          'where' => 'civicrm_login_security_device.fingerprint',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'is_trusted' => [
          'name' => 'is_trusted',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Trusted'),
          'description' => E::ts('Whether the IP address has been validated'),
          'where' => 'civicrm_login_security_device.is_trusted',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'first_seen' => [
          'name' => 'first_seen',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => E::ts('First seen'),
          'description' => E::ts('Date when the IP address was first seen'),
          'where' => 'civicrm_login_security_device.first_seen',
          'default' => 'CURRENT_TIMESTAMP',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
        'last_seen' => [
          'name' => 'last_seen',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => E::ts('Last seen'),
          'description' => E::ts('Date when the IP address was last seen'),
          'where' => 'civicrm_login_security_device.last_seen',
          'default' => 'CURRENT_TIMESTAMP',
          'table_name' => 'civicrm_login_security_device',
          'entity' => 'LoginSecurityDevice',
          'bao' => 'CRM_Loginsecurity_DAO_LoginSecurityDevice',
          'localizable' => 0,
          'add' => '1.0',
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'login_security_device', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'login_security_device', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
