# Login Security

![Screenshot](/images/screenshot.png)

Provides more logging and alerts around CiviCRM logins.

* Keeps a history of recent devices that accessed CiviCRM (with their IP and browser fingerprint). Works for logged-in users, checksum access and API access. Note that it does not keep a full log of pages viewed, only a log of devices. The "last seen" is updated every 15 minutes.
* Provides a global report for administrators.
* Provides a CiviCRM Status Check if there are too many unsuccessful logins (currently supports only Drupal7 and Drupal8/9).

The extension is licensed under [AGPL-3.0](LICENSE.txt).

## Requirements

* PHP v7.2+
* CiviCRM 5.36 or later

## Installation

Install as a regular CiviCRM extension.

## Getting Started

(* FIXME: Where would a new user navigate to get started? What changes would they see? *)

## Using MaxMind's GeoIP database

To display the country of origin of an IP address, the host must have the GeoIP
Geolite2 database by MaxMind. The free (no-cost) databases include the city and
country. You can also get a no-cost license for a more up-to-date copy of the
country database, or subscribe to the paid service for more precise data.

To download, you will need to create an account with MaxMind, then donwload the
databases (for country, and optionally, city).

Then copy the files to `loginsecurity/db/country.mmdb` and `loginsecurity/db/city.mmdb`.

For more information:  
https://dev.maxmind.com/geoip/geolite2-free-geolocation-data?lang=en

This is completely optional. If the databases are not present, the extension
will simply not display the 'Country' column.

## Why a CiviCRM extension?

We wanted a solution that explicitly supported CiviCRM-specific features (API, checksum)
and also tied into CiviCRM's reports and status check (for monitoring). Having details
of access to the CMS only was not a concern, only access to CiviCRM.

Furthermore, Symbiotic supports Drupal7, Drupal8 and WordPress, so we wanted something
that worked on all CMSes in the same way. Most of our clients barely use the CMS, and
one day if CiviCRM Standalone is revived, this extension will already support it.

## Support

Please post bug reports in the issue tracker of this project:  
https://lab.civicrm.org/extensions/loginsecurity/issues

Commercial support is available through Coop SymbioTIC:  
https://www.symbiotic.coop/en

Coop Symbiotic is a worker-owned co-operative based in Canada. We have a strong
experience working with non-profits and CiviCRM. We provide affordable, fast,
turn-key hosting with regular upgrades and proactive monitoring, as well as
custom development and training.
